// =============================================================================
// Copyright (C) DIGITEO - 2010 - Allan CORNET
// Copyright (C) Scilab Enterprises - 2013 - Antoine ELIAS
// =============================================================================
mode(-1);
lines(0);
// =============================================================================
TOOLBOX_NAME  = "xls_link";
TOOLBOX_TITLE = "xls link (Automation) for Scilab";
toolbox_dir   = get_absolute_file_path("builder.sce");
// =============================================================================
// Check Scilab's version
// =============================================================================
try
  v = getversion("scilab");
catch
  error(gettext("Scilab 5.4 or more is required."));
end

if v(1) <= 5 && v(2) < 4 then
  error(gettext('Scilab 5.4 or more is required.'));
end
clear v;
// =============================================================================
// Action
// =============================================================================
if getos() == 'Windows' then
    setenv('SCIDir', SCI + filesep());
    if win64() then
        if (getenv('DEBUG_SCILAB_DYNAMIC_LINK','NO') == 'YES') then
            cmdline = 'devenv ' + toolbox_dir + 'xls_link.sln /Rebuild ""Debug|x64""';
        else
            cmdline = 'devenv ' + toolbox_dir + 'xls_link.sln /Rebuild ""Release|x64""';
        end
    else
        if (getenv('DEBUG_SCILAB_DYNAMIC_LINK','NO') == 'YES') then
            cmdline = 'devenv ' + toolbox_dir + 'xls_link.sln /Rebuild ""Debug|Win32""';
        else
            cmdline = 'devenv ' + toolbox_dir + 'xls_link.sln /Rebuild ""Release|Win32""';
        end
    end

    [output, bOK, exitcode] = dos(cmdline);
    if (ilib_verbose() > 1 | ~bOK) then
        disp(output);
    end

    clear output;
    clear bOK;
    clear exitcode;
    clear cmdline;

    clear findmsvccompiler;
    tbx_builder_macros(toolbox_dir);
    tbx_builder_help(toolbox_dir);
else
    warning("Only for Windows Environment.");
end
// =============================================================================
// Clean variables
// =============================================================================
clear toolbox_dir TOOLBOX_NAME TOOLBOX_TITLE;
clear tbx_builder_macros
clear tbx_builder_help
clear tbx_build_loader
clear tbx_build_cleaner
// =============================================================================
