/*--------------------------------------------------------------------------*/
/* Allan CORNET */
/* DIGITEO 2008 - 2010 */
/*--------------------------------------------------------------------------*/
#include "gw_xls_link.h"
#include "api_scilab.h"
#include "MALLOC.h"

#define SIZE_CURRENT_GENERIC_TABLE(tab) (sizeof(tab) / sizeof(gw_generic_table))

typedef int (*function_Interf)(char *fname,unsigned long l);

typedef struct functions_table_struct {
	function_Interf f; /** the function itself **/
	char const * const name;      /** its name in Scilab **/
	/* char const * const , to remove some warnings -Wall (linux) */
} gw_generic_table;

extern void callFunctionFromGateway(gw_generic_table *Tab,int sizeTab);

/*--------------------------------------------------------------------------*/
static gw_generic_table Tab[] = {
    {sci_XLS_IsExcelRunning,"xls_IsExcelRunning"},
    {sci_XLS_NewExcel,"xls_NewExcel"},
    {sci_XLS_Quit,"xls_Quit"},
    {sci_XLS_RecoverExcel,"xls_RecoverExcel"},
    {sci_XLS_SetPic,"xls_SetPic"},
    {sci_XLS_OffsetRange,"xls_OffsetRange"},
    {sci_XLS_getProperty, "xls_getProperty"},
    {sci_XLS_setProperty, "xls_setProperty"},
    {sci_XLS_callMethod, "xls_callMethod"},
    {sci_XLS_convertSaveFormat, "xls_convertSaveFormat"},
    {sci_XLS_ExtendRange, "xls_ExtendRange"},
    {sci_XLS_CallMacro, "xls_CallMacro"},
    {sci_XLS_GetRange, "xls_GetRange"}
};
/*--------------------------------------------------------------------------*/ 
int C2F(gw_xls_link)(void)
{
    Rhs = Max(0, Rhs);

	if(pvApiCtx == NULL)
	{
		pvApiCtx = (StrCtx*)MALLOC(sizeof(StrCtx));
	}

	pvApiCtx->pstName = (char*)Tab[Fin-1].name;

    callFunctionFromGateway(Tab, SIZE_CURRENT_GENERIC_TABLE(Tab));
    return 0;
}
/*--------------------------------------------------------------------------*/
