/*
 * Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
 * Copyright (C) 2013 - Scilab Enterprises - Antoine ELIAS
 *
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 *
 */

#include "MainObject.hxx"
#include "getInputArgument.hxx"
/*--------------------------------------------------------------------------*/
extern "C" 
{
    #include <stdlib.h>
    #include <api_scilab.h>
	#include <localization.h>
	#include <Scierror.h>
	#include <MALLOC.h>
	#include "gw_xls_link.h"
}

int sci_XLS_CallMacro(char* /*fname*/,unsigned long /*fname_len*/)
{
    VARIANT* pvArgs = NULL;

    CheckInputArgumentAtLeast(pvApiCtx, 1);
    CheckOutputArgument(pvApiCtx, 1, 1);

    int iRhs = nbInputArgument(pvApiCtx);

    pvArgs = (VARIANT*)MALLOC(sizeof(VARIANT) * iRhs);

    for(int i = 0 ; i < iRhs ; i++)
    {
        int* piAddrArg = NULL;
        getVarAddressFromPosition(pvApiCtx, i + 1, &piAddrArg);
        pvArgs[i] = getVariant(piAddrArg);
    }

    ExcelLink *currentObjExcelLink = getObjExcelLink();

    VARIANT vResult = currentObjExcelLink->callMethod(L"Application", L"Run", pvArgs, iRhs);

    if(vResult.vt == VT_ERROR)
    {
        createScalarBoolean(pvApiCtx, nbInputArgument(pvApiCtx) + 1, 0);
    }
    else
    {
        createScalarBoolean(pvApiCtx, nbInputArgument(pvApiCtx) + 1, 1);
    }

    AssignOutputVariable(pvApiCtx, 1) = nbInputArgument(pvApiCtx) + 1;
    ReturnArguments(pvApiCtx);
    return 0;
}
/*--------------------------------------------------------------------------*/
