// ====================================================================
// Allan CORNET
// DIGITEO 2008 - 2010
// ====================================================================
// <-- JVM NOT MANDATORY --> 
// ====================================================================
tlbxs = atomsGetInstalled();
if grep(tlbxs, "xls_link") <> [] then
  atomsLoad("xls_link");
else
  root_path = getenv('TOOLBOX_XLS_LINK_PATH', '');
  if root_path <> '' then 
    exec(root_path + 'loader.sce'); 
  end 
end

r = xls_NewExcel();
if r <> %t then pause, end;

r = xls_AddWorkbook();
if r <> %t then pause, end;

ver_excel_num = eval(xls_GetExcelVersion());
if ver_excel_num == 12 | ver_excel_num == 14 then
  max_cell_xls = "XFD1048576";
else
  max_cell_xls = "IV65536";
end

ierr = execstr('xls_CalculateRange()','errcatch');
if ierr == 0 then pause,end;

ierr = execstr('xls_CalculateRange(''112A11'',[1 1])','errcatch');
if ierr == 0 then pause,end;

ierr = execstr('xls_CalculateRange(''A1'',[1 1])','errcatch');
if ierr <> 0 then pause,end;

ierr = execstr('xls_CalculateRange(max_cell_xls,[1 1])','errcatch');
if ierr <> 0 then pause,end;

if xls_CalculateRange(max_cell_xls,[1 1]) <> max_cell_xls then pause,end
if xls_CalculateRange('A1',[1 1])<> 'A1' then pause,end
if xls_CalculateRange('A1',[1 2])<> 'A1:B1' then pause,end
if xls_CalculateRange('A1',[2 2])<> 'A1:B2' then pause,end
if xls_CalculateRange('AZ1',[2 2])<> 'AZ1:BA2' then pause,end

if xls_SetSave(%t) <> %t then pause,end
if xls_Close() <> %t then pause,end
if xls_Quit() <> %t then pause,end
