// ====================================================================
// Antoine ELIAS
// Scilab Enterprises 2013
// ====================================================================
// <-- JVM NOT MANDATORY -->
// ====================================================================
tlbxs = atomsGetInstalled();
if grep(tlbxs, "xls_link") <> [] then
  atomsLoad("xls_link");
else
  root_path = getenv('TOOLBOX_XLS_LINK_PATH', '');
  if root_path <> '' then
    exec(root_path + 'loader.sce');
  end
end

r = xls_NewExcel();
if r <> %t then pause,end
test_path = xls_getRootPath() + 'tests' + filesep() + 'unit_tests' + filesep();
r = xls_Open(test_path+'xls_CallMacro.xls');
if r <> %t then pause,end
r = xls_SetWorksheet(1);
if r <> %t then pause,end
r = xls_SetData("A1", "");
if r <> %t then pause,end

r = xls_CallMacro("Sheet1.TestMacro1");
if r <> %t then pause,end
data = xls_GetData("A1");
if data <> "TestMacro1" then pause,end

r = xls_CallMacro("Sheet1.TestMacro2", "TestMacro2");
if r <> %t then pause,end
data = xls_GetData("A1");
if data <> "TestMacro2" then pause,end

r = xls_CallMacro("Sheet1.TestMacro2", 1);
if r <> %t then pause,end
data = xls_GetData("A1");
if data <> 1 then pause,end

r = xls_CallMacro("Sheet1.TestMacro2", %t);
if r <> %t then pause,end
data = xls_GetData("A1");
if data <> %t then pause,end

r = xls_CallMacro("Sheet1.TestMacro3", "A1", "TestMacro3");
if r <> %t then pause,end
data = xls_GetData("A1");
if data <> "TestMacro3" then pause,end

r = xls_CallMacro("Sheet1.TestMacro3", "A1", 1000);
if r <> %t then pause,end
data = xls_GetData("A1");
if data <> 1000 then pause,end

r = xls_CallMacro("Sheet1.TestMacro3", "A1", %t);
if r <> %t then pause,end
data = xls_GetData("A1");
if data <> %t then pause,end

r = xls_SetSave(%t);
if r <> %t then pause,end
r = xls_Close();
if r <> %t then pause,end
r = xls_Quit();
if r <> %t then pause,end

