// ====================================================================
// Allan CORNET
// DIGITEO 2008 - 2010
// ====================================================================
// <-- JVM NOT MANDATORY --> 
// ====================================================================
tlbxs = atomsGetInstalled();
if grep(tlbxs, "xls_link") <> [] then
  atomsLoad("xls_link");
else
  root_path = getenv('TOOLBOX_XLS_LINK_PATH', '');
  if root_path <> '' then 
    exec(root_path + 'loader.sce'); 
  end 
end

test_path = xls_getRootPath() + 'tests' + filesep() + 'unit_tests' + filesep();

if xls_IsExcelRunning() <> %f then pause,end
r = xls_NewExcel();
if r <> %t then pause,end

r = xls_Open(test_path+'xls_GetData.xls');
if r <> %t then pause,end

r = xls_SetWorksheet(1);
if r <> %t then pause,end

v = xls_GetData('A1');
if type(v)<> 1 then pause,end
if v<>1 then pause,end

v = xls_GetData('IntType');
if type(v)<> 1 then pause,end
if v<>1 then pause,end

v = xls_GetData('B4');
if type(v)<> 1 then pause,end
if v<>1.2 then pause,end

v = xls_GetData('DoubleType');
if type(v)<> 1 then pause,end
if v<>1.2 then pause,end

v = xls_GetData('A12');
if type(v)<> 10 then pause,end
if v<>'Test' then pause,end

v = xls_GetData('StringType');
if type(v)<> 10 then pause,end
if v<>'Test' then pause,end

v = xls_GetData('B13');
if type(v)<> 1 then pause,end
if v<>[] then pause,end

v = xls_GetData('EmptyType');
if type(v)<> 1 then pause,end
if v<>[] then pause,end

v = xls_GetData('A14');
if type(v)<> 1 then pause,end
if v <> 0.5625 then pause,end

v = xls_GetData('TimeType');
if type(v)<> 1 then pause,end
if v <> 0.5625 then pause,end

v = xls_GetData('A15');
if type(v)<> 10 then pause,end
if v <> '12/08/1989' then pause,end

v = xls_GetData('DateType');
if type(v)<> 10 then pause,end
if v <> '12/08/1989' then pause,end

v = xls_GetData('A16');
if type(v)<> 1 then pause,end
if v <> -1326.1 then pause,end

v = xls_GetData('NegType');
if type(v)<> 1 then pause,end
if v <> -1326.1 then pause,end

v = xls_GetData('A17');
if type(v)<> 1 then pause,end
if v <> 14 then pause,end

v = xls_GetData('EuroType');
if type(v)<> 1 then pause,end
if v <> 14 then pause,end

v = xls_GetData('A18');
if type(v)<> 10 then pause,end
if v <> '14/03/2001' then pause,end

v = xls_GetData('DateType2');
if type(v)<> 10 then pause,end
if v <> '14/03/2001' then pause,end

v = xls_GetData('A19');
if type(v)<> 10 then pause,end
if v <> '30/100' then pause,end

v = xls_GetData('StringType2');
if type(v)<> 10 then pause,end
if v <> '30/100' then pause,end

v = xls_GetData('A20');
if type(v)<> 1 then pause,end
if v <> 1.000D+99 then pause,end

v = xls_GetData('ExpoType');
if type(v)<> 1 then pause,end
if v <> 1.000D+99 then pause,end

v = xls_GetData('A21');
if type(v)<> 1 then pause,end
if v <> -1.000D-99 then pause,end

v = xls_GetData('ExpoType2');
if type(v)<> 1 then pause,end
if v <> -1.000D-99 then pause,end

v = xls_GetData('D1:G2');
if type(v)<> 1 then pause,end
if or(size(v) <> 0) then pause,end
if v <> [] then pause,end

v = xls_GetData('EmptyMatrixType');
if type(v)<> 1 then pause,end
if or(size(v) <> 0) then pause,end
if v <> [] then pause,end

ref_1 = [1 2 3;4 5 6];
v = xls_GetData('A1:C2');
if type(v)<>1 then pause,end
if or(size(v) <> [2 3]) then pause,end
if or(ref_1 <> v) then pause,end

v = xls_GetData('IntMatrixType');
if type(v)<>1 then pause,end
if or(size(v) <> [2 3]) then pause,end
if or(ref_1 <> v) then pause,end

ref_2 = [1.1 1.2 1.3;1.4 1.5 1.6];
v = xls_GetData('A4:C5');
if type(v)<>1 then pause,end
if or(size(v) <> [2 3]) then pause,end
if or(ref_2 <> v) then pause,end

v = xls_GetData('DoubleMatrixType');
if type(v)<>1 then pause,end
if or(size(v) <> [2 3]) then pause,end
if or(ref_2 <> v) then pause,end

ref_3 = [ 'A' 'B' 'C';'D' 'E' 'F';'G' 'H' 'I'];
v = xls_GetData('E7:G9');
if type(v)<>10 then pause,end
if or(size(v) <> [3 3]) then pause,end
if or(ref_3 <> v) then pause,end

v = xls_GetData('StringMatrixType');
if type(v)<>10 then pause,end
if or(size(v) <> [3 3]) then pause,end
if or(ref_3 <> v) then pause,end

ref_4 = [string(ref_1); '' '' '' ;string(ref_2)];
ref_4 = strsubst(ref_4,'.',',');
v = xls_GetData('A1:C5');
if type(v)<>10 then pause,end
if or(size(v) <> [5 3]) then pause,end
if or(ref_4 <> v) then pause,end

v = xls_GetData('BigDoubleMatrixType');
if type(v)<>10 then pause,end
if or(size(v) <> [5 3]) then pause,end
if or(ref_4 <> v) then pause,end

ref_5 = ['1'	'A'	'B'	'2' ''	; 'Test'	'3'	'Scilab'	'4'	'Datas'];
v = xls_GetData('A11:E12');
if type(v)<>10 then pause,end
if or(size(v) <> [2 5]) then pause,end
if or(ref_5 <> v) then pause,end

v = xls_GetData('BigStringMatrixType');
if type(v)<>10 then pause,end
if or(size(v) <> [2 5]) then pause,end
if or(ref_5 <> v) then pause,end

ref_6 = ['Tests ' 'Automation xls_GetData'];
v = xls_GetData('A23:B23');
if type(v)<>10 then pause,end
if or(size(v) <> [1 2]) then pause,end
if or(ref_6 <> v) then pause,end

v = xls_GetData('AnotherStringMatrixType');
if type(v)<>10 then pause,end
if or(size(v) <> [1 2]) then pause,end
if or(ref_6 <> v) then pause,end

v = xls_GetData('A1:BZ1000');
if or(size(v) <> [1000 78]) then pause,end

ver_excel_num = eval(xls_GetExcelVersion());
if ver_excel_num < 12 then
  max_cell_xls = "IV65536";
else
  max_cell_xls = "XFD1048576";
end

ierr = execstr('v = xls_SelectRange(''A1:''+max_cell_xls);','errcatch');
if ierr <> 0 then pause,end

if ~xls_Close() then pause,end
if ~xls_Quit() then pause,end
