// ====================================================================
// Allan CORNET
// DIGITEO 2008 - 2010
// ====================================================================
// <-- JVM NOT MANDATORY --> 
// ====================================================================
tlbxs = atomsGetInstalled();
if grep(tlbxs, "xls_link") <> [] then
  atomsLoad("xls_link");
else
  root_path = getenv('TOOLBOX_XLS_LINK_PATH', '');
  if root_path <> '' then 
    exec(root_path + 'loader.sce'); 
  end 
end

r = xls_NewExcel();
if r <> %t then pause,end

r = xls_AddWorkbook();
if r <> %t then pause,end

r = xls_SetWorksheet(1);
if r <> %t then pause,end

PI = %pi;
r = xls_SetData('A1',PI);
if r <> %t then pause,end
r1 = xls_GetData('A1');
if abs(r1-%pi) > %eps then pause,end

PI = %pi;
r = xls_SetData('E1:E3',PI);
if r <> %t then pause,end


PI = %pi;
r = xls_SetData('A1:B3',PI);
if r <> %t then pause,end
r1 = xls_GetData('A1:B3');

if r1 <> PI then pause,end

a = [1 2;4 5;6 7];
r = xls_SetData('A5:B7',a);
if r <> %t then pause,end

b = ['Allan' 'CORNET'; 'Digiteo' 'Copyright 2008'];
r = xls_SetData('A9:B10',b);

c = ['Scilab', 'Enterprises', 'is', 'the', 'new', 'maintainer'];
r = xls_SetData('A12:F12',c);

r = xls_SetSave(%t);
if r <> %t then pause,end

r = xls_SaveAs(TMPDIR+filesep()+'test_xls_SetData.xls');
if r <> %t then pause,end

r = xls_Close();
if r <> %t then pause,end

r = xls_Quit();
if r <> %t then pause,end
